//  CS101		  	
//  Lab Batch 75
//  Project - BASIC BANKING APPLICATION SOFTWARE


/*
	The following program is the outcome of a project by the students of 'Batch no-75' of the 'CS101' 
	course during the Autumn semester of 2010 at IIT Bombay. Following are the names and the roll nos 
	of the students who took part in this project :
		1. Snehansu Mallik 			- 10528011
		2. Sunil Kushwaha     		- 10528020
		3. S. Sreelekshmy			- 10528024
		4. Pankaj Kumar				- 10528025
		5. Kirti Nandkishor Gaikwad - 10528027
		6. Deepika Chodavarapu		- 10528028
		7. Jaydeep Das				- 10528029
		8. Anand Abhishek 			- 10528030
		9. Debdip Pal 				- 10528031
		10. A. Gayatri Devi 		- 10528032
		11. Kush Sharma 			- 10528033
		12. Kanhaiyalal Bairwa 		- 08D02022
		13. Birju Das 				- 6103014

*/


/*
	AN INTRODUCTION TO THE PROGRAM

	The purpose of this program is to provide an interface to the Bank Employees so that they can 
	perform the daily transactions for the bank customers keeping in mind the various services the 
	bank provides. It is designed for the bank employee to work on when a customer comes to the bank 
	for transactions (viz. create account, withdaw from account, deposit, etc.).

		For this program to work, two files namely, "records.txt" and "employee.txt" are required. 
	The file "records.txt" shall contain the details of each account holder which includes : 
		1. Account no.
		2. First Name
		3. Last Name
		4. Address
		5. Age
		6. Time of last updation/transaction of the account
		7. Balance
	The program shall take data from this file when it starts and shall update the file every time 
	it is refreshed during the run-time. The details of each account holder is contained in separate 
	lines and the 7 parameters are separated by spaces in the above order. The account no (a 5-digit 
	no.) is the primary parameter and the customers are arranged in its increasing order.
	The "employees.txt" is a similar file that contains the user names and login passwords of all the 
	employees of the bank. 

		The program is segmented and properly sequenced. Broadly, this program with 1100+ lines of 
	coding can be broadly categorised into four parts in following order : 
		1. Calling header files and defining global variables
		2. Function initialisations
		3. Main function
		4. Definition of the other functions
	The 4th segment is the largest and contains definitions of the 16 functions each of them clearly 
	marked out so as to ensure good readability.
	
		The main features of Hamara Bank Pvt. Ltd. (that have been provided in this program) are :
	

*/




#include<iostream>
#include<fstream>
#include<cstring>
#include<string>
#include<cstdio>
#include<cstdlib>
#include<ctime>
#include<cmath>

#define maxval 500
#define maxempl 20

using namespace std ;

	// structure of the acc holder's details
	// each variable holds 6 entities
	// a total of (4+20+20+4+100+8)=160 bytes

struct acc_details 
{
	int acc_no ;
	char first_name[20], last_name[20];
	int age ;
	char address[100] ;
	char domodi[25];
	float balance ;
}acc_holder[maxval];

struct bank_empl 
{
	char name[20] ;
	char pass[20] ;
}empl_details[maxempl];

int no_acc, no_empl ;



// -------------------------		FUNCTION INITIALIZATIONS		-------------------------------

/*	
	Initialising all the user-defined functions that have been used in the program. Here the functions 
	are sequenced in order of their occurance in the program. They are also numbered appropriately. 
	The general nomenclature of the functions are as follows :
		#a		- It is the a-th function called in the main()
		#a.b 	- It is the b-th function called in the #a function
		#a.0.c 	- It is the c-th function which is called by the different functions called by function 
				#a called directly in the main()
	These functions are defined after the main() in following sequence only.
*/


int password_chk() ;				// #1
void login();						// #1.1

void start() ;						// #2

int main_menu_manager() ;			// #3a
int main_menu_employee(int) ;		// #3b
	
int create_acc() ;	 				// #3.1
int deposit() ;		 				// #3.2
int withdrawal() ;	 				// #3.3
int bal_inquiry() ;	 				// #3.4
int transfer() ; 					// #3.5
int del_acc(); 						// #3.6

int change_password(); 				// #3.7
int change_username(); 				// #3.8

int search_acc(int); 				// #3.0.1
int cinterest(int);	 				// #3.0.2

void refresh();						// #4




// -----------------------------			MAIN FUNCTION 			-------------------------------
				

int main()
{	
	int who=0 ;	
	
	system("clear") ;
	
	who=password_chk() ;					// Checking the password
	
	if(who==-1)
	{	
		cout<< "Terminating Program.\n\n" ;
		return 1 ;
	}
	else if(who==0)
	{	
		start();							// Once Manager logs in, the 'records.txt' is tranferred to struct acc_holder[] 
		
		main_menu_manager() ;				// Showing the main menu for manager and correspondingly calling the rest of the functions
		
	}
	
	else
	{
		start() ;							// Once Employee logs in, the 'records.txt' is tranferred to struct acc_holder[] 
		
		main_menu_employee(who) ;			// Showing the main menu for employee and correspondingly calling the rest of the functions
	
	}
	
	refresh() ;								// Once Employee logs out, the 'records.txt' is updated
	
	return 0 ;
}






// -----------------------------		FUNCTION DEFINITIONS		-------------------------------

// -----------------------------				#1					-------------------------------


/*
	Returns -1 if incorrect password is entered thrice, ow. return employee no

*/

int password_chk()
{	
	login();
	string empname, emppassword ;
	int chk=0, i, k=-1 ;
	start:
	cout<< "\nName : " ;
	cin >> empname ;
	cout<< "Password : " ;
	cin >> emppassword ;

							// Check whether the person is a bank employee or not
		
	for(i=0;i<no_empl;i++)
	{
		if((empname==empl_details[i].name)&&(emppassword==empl_details[i].pass))			
		{
			k=i ;
			return k ;
		}
	}
		
	cout<< "Incorrect Entry.\nEnter again. Check if the capslock is on or not.\n\n" ;
	chk++ ;
	if(chk>2)
	{
		cout<< "\nWrong Information entered thrice.\n" ;
		return -1 ;
	}
	goto start;
	
		 		
	
}




// -----------------------------				#1.1					-------------------------------


/*
	Loading the employee data, ie. their login id and password, in the structure array variable 'empl_details[]' 
	from the file "employee.txt".
*/

void login()
{
	int i=0;
	FILE *frec;
						//Opening the txt file in reading mode 

	frec=fopen("employee.txt","r");  	
	while(!feof(frec)&&i<maxempl)
	{
						//Reading each element of the row differntly as....
	
		fscanf(frec,"%s",&empl_details[i].name);			//character
	
		fscanf(frec,"%s",&empl_details[i].pass);			//character
		
		i++;
	}
	
	no_empl =i-1 ;
	
						//Closing the file pointer 

	fclose(frec);
	
	
}


// -----------------------------				#2					-------------------------------


/*
	Reads the details of the account holders from "records.txt" file and stores them in the structure 
	array 'acc_holder[]'. Also counts the total no of account holders in 'no_acc'.
*/

void start()
{
	int i=0;
	FILE *frec;
												//Opening the txt file in reading mode 

	frec=fopen("records.txt","r");  	
	while(!feof(frec)&&i<maxval)
	{
				//Reading each element of the row differntly as....
	
		fscanf(frec,"%d",&acc_holder[i].acc_no);    			//integer
	
		fscanf(frec,"%s",&acc_holder[i].first_name);			//character
	
		fscanf(frec,"%s",&acc_holder[i].last_name);			//character
	
		fscanf(frec,"%s",&acc_holder[i].address);				//character
	
		fscanf(frec,"%d",&acc_holder[i].age);					//integer 
		
		fscanf(frec,"%s",&acc_holder[i].domodi);              //char
	
		fscanf(frec,"%f",&acc_holder[i].balance);				//float
	
		i++;
	}
	no_acc = i-1 ;
	cout<< endl << "\nNumber of accounts : " << no_acc << endl ;

				//Closing the file pointer 

	fclose(frec);
	
				
}



// -----------------------------				#3a					-------------------------------


/*
	Displays the menu for the manager of the bank. The manager has all the options at his/her display 
	at each of which a function is called for and the necessary work are carried out.
*/

int main_menu_manager() 
{
	char choice, c ;
	int i,flag=1,a ;	
	
	do
	{	system("clear");
			
		printf("\n\n \t\t\t\t \t\t\tHamara Bank\n\n\n") ;
		cout<< "\t\tHello " << empl_details[0].name 
			<< "\n\t\t\t\t\t\t\t\t\t\t\t\t\tu- Change Username"
         	<< "\n\t\t\t\t\t\t\t\t\t\t\t\t\tp- Change Password\n\n" ;
		cout<< "\n\t\t\t1. Create an Account" 
			<< "\t\t\t\t\t2. Deposit"
			<< "\n\t\t\t3. Withdrawal        "
			<< "\t\t\t\t\t4. Balance Inquiry"
			<< "\n\t\t\t5. Money Transfer    "
			<< "\t\t\t\t\t6. Close an Account"
			<< "\n\n\t\t\tx- Exit            " 
			<< "\t\t\t\t\tr- Refresh\n" 
			<< "\n\n\n\nEnter the option : " ;
		cin >> choice ;
		cout<< "\n\n\n" ;
		
			
		switch(choice)
		{	case '1':
				a=create_acc() ;				
				break ;
			case '2':
				deposit() ;
				break ;
			case '3':
				withdrawal() ;
				break ;
			case '4':
				bal_inquiry() ;
				break ;
			case '5':
				transfer() ;
				break ;
			case '6':
				del_acc();
				break ;
			case 'u':
				cout<<change_username();
				break;
         	case 'p':
                change_password();
                break; 
			case 'x':
				flag=0;
				break ;
			case 'r':
				refresh() ;
				break ;
			default:
				cout<< "\nWrong Option. Enter again.\n" ;
				cout<< "\nPress any key." ;
				cin >> c ;
				cout<< "\n\n" ;

		}
	}while(flag) ;

	return 0 ;

}


// -----------------------------				#3b					-------------------------------


/*
	Displays the menu for the general emplopyee of the bank. This employee does not have all the options 
	that the bank manager has, eg. he/she can not create an account or delete an account. To do that a 
	customer has to go to the bank manager.
*/

int main_menu_employee(int emp_no)
{
	char choice, c ;
	int i,flag=1 ;	
	
	do
	{	system("clear");
			
		printf("\n\n \t\t\t\t \t\t\tHamara Bank\n\n\n") ;
		cout<< "\t\tWelcome " << empl_details[emp_no].name  
			<< "\n\t\t\t\t\t\t\t\t\t\t\t\t\tu- Change Username"
         	<< "\n\t\t\t\t\t\t\t\t\t\t\t\t\tp- Change Password\n\n" ;
		cout<< "\n\t\t\t1. Deposit           " 
			<< "\t\t\t\t\t2. Withdrawal"
			<< "\n\t\t\t3. Balance Inquiry   "
			<< "\t\t\t\t\t4. Money Transfer"
			<< "\n\n\t\t\tx- Exit            " 
			<< "\t\t\t\t\tr- Refresh\n" 
			<< "\n\n\n\nEnter the option : " ;
		cin >> choice ;
		cout<< "\n\n\n" ;
		
			
		switch(choice)
		{	case '1':
				deposit() ;
				break ;
			case '2':
				withdrawal() ;
				break ;
			case '3':
				bal_inquiry() ;
				break ;
			case '4':
				transfer() ;
				break ;
			case 'u':
                cout<<change_username();
                break;
         	case 'p':
                change_password();
                break; 
			case 'x':
				flag=0;
				break ;
			case 'r':
				refresh() ;
				break ;
			default:
				cout<< "\nWrong Option. Enter again.\n" ;
				cout<< "\nPress any key." ;
				cin >> c ;
				cout<< "\n\n" ;

		}
	}while(flag) ;

	return 0 ;

}



// -----------------------------				#3.1					-------------------------------


/*
	This function provides the option for creating a new account. Thi function is provided only for 
	the manager (ie. in the main_menu_maneger()) because a new account has to be created under the 
	supervision of the bank manager. This function takes the account holder's details like name, age, 
	address and the opening balance. Note that there are certain clauses for entering age, address 
	and opening account. The clause of address is only technical while the other two are by rule of 
	the bank.
		It also generates the new account no as the next integer to the last account no in the acc_holder[].
*/

int create_acc()
{
	int i ;
	char c, chkage=0 ;
	i=no_acc ;
	
	                             //Generating Date 
	time_t rawtime;
  	struct tm * timeinfo;

  	time ( &rawtime );
  	timeinfo = localtime ( &rawtime );

  	strftime (acc_holder[i].domodi,25,"%m/%d/%Y:%H:%M:%S",timeinfo);
  	
  	
	
	system("clear");
	
	printf("\n\n \t\t\t\t \t\t\tHamara Bank\n\n") ;
	printf("\n\n \t\t\t\t \t\t\tCreating Account\n\n") ;
	
	cout<< "\nEnter first name : \t " ;
	cin >> acc_holder[i].first_name ;
	cout<< "\nEnter last name : \t " ;
	cin >> acc_holder[i].last_name ; 
	
	start:
	cout<< "\nEnter age : \t " ;
	cin >> acc_holder[i].age ;
	
	if(acc_holder[i].age<18)	// Checking for minimum age 
	{	
		chkage++ ;
		cout<< "\nThe person is not eligible. She/He should be 18 or older.\n" ;
		if(chkage>2)
		{
			cout<< "Wrong age entered thrice.\nAborting.\n" ;
			return -1 ;
		}
		goto start ;
	}
				       
	cout<< "\nEnter address (Put an underscore for space) :\n\t\t" ;
	cin >> acc_holder[i].address ;
	
	start1:
	cout<< "\nEnter opening amount : " ;
	cin >> acc_holder[i].balance ;
	
								// Checking for proper balance
	if(acc_holder[i].balance<500.00||acc_holder[i].balance>5000000.00)
	{
		cout<< "\nPlease deposit an amout between 500 and 50,00,000.\n" ;
		goto start1 ;
	}
    	
								// Generating the account no
	acc_holder[i].acc_no = acc_holder[i-1].acc_no+1 ;						
	cout<< "\n\n\nAccount has been created.\nAccount number is : \t " 
		<< acc_holder[i].acc_no ;
		
			
	no_acc++ ;					// Updating the total no of accounts
	
	cout<< "\n\nPress any key to go to Main Menu." ;
	cin >> c ;
	cout<< "\n\n" ;
	
	 
	return 1;
}




// -----------------------------				#3.2					-------------------------------


/*
	This function provides the option for deposition of money into the account
*/

int deposit()
{
	flag:
	int k, acc_no, depos=0, i=0, l ;
	char chk, c ;
	
	system("clear");
	
	printf("\n\n \t\t\t\t \t\t\tHamara Bank\n\n\n") ;
	printf("\n\n \t\t\t\t \t\t\tDeposit\n\n\n") ;
	cout<< "Enter the Account no : " ; 
	cin >> acc_no; 								// To deposit in this account
	
	cout<< "\nEntered acc_no : " << acc_no ; 						
	cout<< "\n\nIf wrongly entered, press 0 else, press any key : "<<endl ;
	cin >> chk ;
	if(chk==48)	goto flag ;
			
	
	k=search_acc(acc_no);
	
	if(k==-1)									//Account does not exist
	{
		cout<< "Entered account number does not exist."
		    << "Going to Main Menu.\n\n";
		return 1 ;							//To go to main manu 
		
	}
	else	
	{
		cinterest(k);	
							//To show the account details of account holder

		cout<< "\nAccount no : " << acc_holder[k].acc_no ;
		cout<< "\nName       : " << acc_holder[k].first_name << " " << acc_holder[k].last_name ;
		cout<< "\nAge        : " << acc_holder[k].age ;
		cout<< "\nBalance    : " << acc_holder[k].balance << endl;

							//To deposit in the account
		flag1:
		cout<< "\nAmount to be deposited : " ;
		cin >> depos ;
		
							// Checking whether employee has entered correctly or not								

		cout<< "\nEntered amount : \t " << depos 
			<< "\nIf wrongly entered, press 0 otherwise, press 1   : \t " ;
		cin >> chk ;
		if(chk==48)	goto flag1 ;
					
														
		acc_holder[k].balance = acc_holder[k].balance+depos ;						// To update the accout database
		cout<< "Updated new balance is " << acc_holder[k].balance << endl ;		// To show the new balance...
	}
	
	cout<< "\nPress any key to go to Main Menu." ;
	cin >> c ;
	cout<< "\n\n" ;
	
	return 0 ;
	
}



// -----------------------------				#3.3					-------------------------------


/*

*/

int withdrawal()
{	
	int acc_no, i=0, valid=0 ;
	int amount, k ;
	char chk, c ;

	flag2:
	system("clear");
	
	printf("\n\n \t\t\t\t \t\t\tHamara Bank\n\n\n") ;
	cout<< "\n \t\t\t\t \t\t\tWithdrawal\n" ;
	
	cout<< "\n\nEnter the Acc no : " ;
	cin >> acc_no ;
	
						// Checking whether employee has entered correctly or not					

	cout<< "\nEntered acc_no : " << acc_no 						
		<< "\nIf wrongly entered, press 0 else, press any key : " ;
	cin >> chk ;
	if(chk==48)	goto flag2 ;
	
	k=search_acc(acc_no);
	
	if(k==-1)									//Account does not exist
	{
		cout<< "Wrong account number entered."
		    << "Going to Main Menu.\n\n";
		return 1 ;							//To go to main manu 
		
	}
	else	
	{
		//To show the account details of account holder
 		cinterest(k);	
		cout<< "\nThe details of the account holder are :\n"
			<< "\n\tName    : " << acc_holder[k].first_name << " " << acc_holder[k].last_name
			<< "\n\tAge     : " << acc_holder[k].age
		    << "\n\tBalance : " << acc_holder[k].balance << "\n\n" ;
	
		flag:
		cout<< "\n\nEnter the amount to be withdrawn : \t " ;
		cin >> amount ;
			
						// Checking whether employee has entered correctly or not
		cout<< "\nEntered amount : \t " << amount 
			<< "\nIf wrongly entered, press 0\n\t\tElse, press 1   : \t " ;
		cin >> chk ;
		if(chk==48)	goto flag ;
					
						// Checking whether customer has enough money to withdraw or not
		if(amount>(acc_holder[i].balance-500))		
		{	
			cout<< "\nCan not be withdrawn."
				<< "\nMust keep at least Rs 500 in the account.\n" 
				<< "\nGoing to Main Menu." ;
			
		}
			
						// Balance withdrawn & updated
		else
		{
			acc_holder[i].balance-=amount ;
			cout<< "\nAmount can be withdrawn.\n"
				<< "\nUpdated balance : \t " << acc_holder[i].balance << "\n\n" ;
		}
						
			
	}
	
	cout<< "\nPress any key to go to Main Menu." ;
	cin >> c ;
	cout<< "\n\n" ;
		
	return 0 ;
	
}




// -----------------------------				#3.4					-------------------------------


/*

*/

int bal_inquiry()
{
	int k, acc_no, l ;
	char chk, c ;

	flag:
	system("clear");

	printf("\n\n \t\t\t\t \t\t\tHamara Bank\n\n\n") ;
	printf("\n\n \t\t\t\t \t\t\tBalance Inquiry\n\n\n") ;
	
	cout<< "Enter the Account no : " ; 
	cin >> acc_no ; 								// To search for the account
	
	cout<< "\nEntered acc_no : " << acc_no ; 						
	cout<< "\n\nIf wrongly entered, press 0 else, press any key : "<<endl ;
	cin >> chk ;
	if(chk==48)	goto flag ;
			
	
	k=search_acc(acc_no);
	
	if(k==-1)									//Account does not exist
	{
		cout<< "Account number does not exist."
		    << "Going to Main Menu.\n\n";
		return 1 ;							//To go to main manu 
		
	}
	else	
	{
		//To show the account details of account holder
 		cinterest(k);	
		cout<< "\nThe details of the account holder are :\n"
			<< "\n\tName    : " << acc_holder[k].first_name << " " << acc_holder[k].last_name
			<< "\n\tAge     : " << acc_holder[k].age
		    << "\n\tBalance : " << acc_holder[k].balance << "\n\n" ;
	
	
	}

	cout<< "\nPress any key to go to Main Menu." ;
	cin >> c ;
	cout<< "\n\n" ;
		
	return 0 ;
}



// -----------------------------				#3.5					-------------------------------


/*

*/

int transfer()

{
    indicator1:
	int k1=-1,k2=-1, acc_search1,acc_search2, trans=0, i=0, l ;
	char chk, c ;
	system("clear");
	
	printf("\n\n \t\t\t\t \t\t\tHamara Bank\n\n\n") ;
	cout<< "\n \t\t\t\t \t\t\tBalance Transfer\n\n\n" ;
	
	cout<< "\nEnter the Account no. from whom money will be transferred: " ; 
	cin >> acc_search1; 								// To deposit in this account
	
	cout<< "\nEnter the Account no to which money will be transferred: " ; 
	cin >> acc_search2; 								// To deposit in this account
	cout<< endl;		
	
	k1=search_acc(acc_search1) ;
	k2=search_acc(acc_search2) ;
	
	
	if(k1==-1||k2==-1)										// Account does not exist
	{
		cout<< "Entered account number does not exist."
			<< "\nPress 0 to enter again, Press any key to go to Main Menu : \t" ;    
		cin >> chk ;
		
		if(chk==48)
			goto indicator1 ;
		else
		{
			cout<< endl ;
			return 1 ;
		}
	}
	else	
	{	
		flag1:
		cout<< "\nEnter amount to be transferred : " ;
		cin >> trans ;
		
							// Checking whether employee has entered correctly or not								

		cout<< "\nEntered amount : \t " << trans 
			<< "\nIf wrongly entered, press 0 else, press any key   : \t " ;
		cin >> chk ;
		if(chk==48)	
        	goto flag1 ;
		
		if(trans>(acc_holder[i].balance-500))		
		{	
			cout<< "\nCan not be withdrawn."
				<< "\nMust keep at least Rs 500 in the account.\n" 
				<< "\nGoing to Main Menu." ;
			
		}
			
							// Balance withdrawn & updated
		else
		{
			acc_holder[i].balance-=trans ;
			cout<< "\nAmount can be withdrawn.\n"
				<< "\nUpdated balance : \t " << acc_holder[i].balance << "\n\n" ;
				
							//To show the account details of 2 account holders
							
			cinterest(k1);        
        	cout<<"\n\nThe account detail from which money will be transferred:";
			cout<< "\nAccount no : " << acc_holder[k1].acc_no ;
			cout<< "\nName       : " << acc_holder[k1].first_name << " " << acc_holder[k1].last_name ;
			cout<< "\nAge        : " << acc_holder[k1].age ;
			cout<< "\nBalance    : " << acc_holder[k1].balance << endl;
					
			acc_holder[k1].balance = acc_holder[k1].balance-trans ;												
			acc_holder[k2].balance = acc_holder[k2].balance+trans ;						// To update the accout database

			cout<< "\nUpdated new balance from whom the balance is transfered:";
        	cout<< acc_holder[k1].balance;

		}
	
	}
	
	cout<< "\n\nPress any key to go to Main Menu. " ;
	cin >> c ;
	cout<< "\n\n" ;
	
	return 0 ;
	
}	



// -----------------------------				#3.6					-------------------------------


/*

*/

int del_acc()
{ 
	int acc_no,i=0,valid=0,k;
	char chk,ans,c;
 
	flag:

	system("clear");
	
	printf("\n\n \t\t\t\t\t\t\tHamara Bank\n\n\n") ;
	printf("\n\n \t\t\t\t\t\t Deletion of Account\n\n\n") ;
	
	cout<< "Enter the account number to be deleted : ";
	cin >> acc_no;
	
	cout<< "\nEntered acc_no : " << acc_no; 						
	cout<< "\n\nIf wrongly entered, press 0 else, press any key : "<<endl ;
	cin >> chk ;
	if(chk==48)	goto flag ;
	
	k=search_acc(acc_no);
	
	if(k==-1)									//Account does not exist
	{
		cout<< "Entered account number does not exist." ;
		    	
	}
	else	
	{
		//To show the account details of account holder
 		cinterest(k);
		cout<< "\nThe details of the account holder are :\n"
			<< "\n\tName    : " << acc_holder[k].first_name << " " << acc_holder[k].last_name
			<< "\n\tAge     : " << acc_holder[k].age
		    << "\n\tBalance : " << acc_holder[k].balance << "\n\n" ;
	
		cout<< "\n\nAre you sure you want to delete the account?  \t " 
			<<"\nIf yes press 1. Otherwise press 0  "<<endl;
		cin >> ans ;
			
		if(ans!=48)	
		{
			for( i=k;i<no_acc-1;i++)
			{
				strcpy(acc_holder[i].first_name,acc_holder[i+1].first_name);
				strcpy(acc_holder[i].last_name,acc_holder[i+1].last_name);
				acc_holder[i].age=acc_holder[i+1].age;
				acc_holder[i].balance=acc_holder[i+1].balance;
				strcpy(acc_holder[i].domodi,acc_holder[i+1].domodi);
				strcpy(acc_holder[i].address,acc_holder[i+1].address);
				acc_holder[i].acc_no=acc_holder[i+1].acc_no;
			} 
		              
			cout<<"Account has been deleted!"<<endl;
			no_acc--;				
			
		}
							
			
	}
	
	
	cout<< "\nPress any key to go to Main Menu." ;
	cin >> c ;
	cout<< "\n\n" ;
	
	return 0 ;  
  
}  



// -----------------------------				#3.7					-------------------------------

/*
	function to change username
*/

int change_username()
{
	FILE *frec;
	int count1=0,position=-1,chk=0;
	string oldusername,password;
	char newusername1[20],newusername2[20];
	
	start:
	cout<<"\nEnter your existing username : ";
	cin>>oldusername;
	cout<<"\nEnter your password : ";
	cin>>password;
       
		
	for(count1=0;count1<no_empl;count1++)
	{										// Check whether the person is a bank employee or not
		if((oldusername==empl_details[count1].name)&&(password==empl_details[count1].pass))			
		
			position=count1 ;
         
	}
	
	if(position<0&&chk<=1)	
	{
		cout<< "Incorrect Entry.\nEnter again.\n\n" ;
		chk++ ;
		goto start;
	}
	if(chk>1)
	{	
		cout<< "\nWrong Information entered thrice.\n" ;
		return 0;
	}
	

	start1:
	cout<< "\n\nEnter your new username :  ";
	cin >> newusername1;
	cout<< "\n\nEnter the new username again : "; 
	cin >> newusername2;

	if(strcmp(newusername1,newusername2))
	{	
		cout<<"\n New usernames do not match...Please re-enter again.\n";

		goto start1;
       
	}

	else 
		strcpy(empl_details[position].name,newusername1);
      




	frec=fopen("employee.txt","w+");
	int i=0;

				//Writing the updated records in employee.txt

	while(i<no_empl)
	{
		fprintf(frec," %s %s \n", empl_details[i].name, empl_details[i].pass);
 	
		i++;
	}
	
	cout<<"\n\nUsername successfully changed !\n";
     
				//Closing the file pointer 

	fclose(frec);
    
	return 0;


} 





// -----------------------------				#3.8					-------------------------------

/*
	function to change password
*/ 

int change_password()
{
	FILE *frec;
	int count1=0,position=-1,chk=0;
	string oldpassword,username;
	char newpassword1[20],newpassword2[20];
	
	start:
	cout<< "\nEnter username : ";
	cin >> username;
	cout<< "\nEnter your existing password : ";
	cin >> oldpassword;
       
	for(count1=0;count1<no_empl;count1++)
	{									// Check whether the person is a bank employee or not
		if((username==empl_details[count1].name)&&(oldpassword==empl_details[count1].pass))			
		
			position=count1 ;
         
			
	}
	
	if(position<0&&chk<=1)	
	{
		cout<< "Incorrect Entry.\nEnter again.\n\n" ;
		chk++ ;
		goto start;
	}
	if(chk>1)
	{
		cout<< "\nWrong Information entered thrice.\n" ;
		return 0;
	}
	


	start1:
	cout<< "\n\nEnter your new password :  ";
	cin >> newpassword1;
	cout<< "\n\nEnter the new password again : "; 
	cin >> newpassword2;

	if(strcmp(newpassword1,newpassword2))
	{
		cout<<"\n Passwords do not match...Please enter again.\n";
		goto start1;
	}

	else 
		strcpy(empl_details[position].pass,newpassword1);
      




	frec=fopen("employee.txt","w+");
	int i=0;

				//Writing the updated records in employee.txt

	while(i<no_empl)
	{
		fprintf(frec," %s %s \n", empl_details[i].name, empl_details[i].pass);
 	
		i++;
	}
	
	cout<<"\n\nPassword successfully changed !\n";
     
				//Closing the file pointer 

	fclose(frec);
    
	return 0;


}

			
											

         
// -----------------------------				#3.0.1					-------------------------------

/*
	To search for an account no in the structure acc_holder[].
	
	The function is used to compare the account nos in the struct array (acc_holder[]) with an account no given as argument (acc_no) 
	and to return -1 if such an account no does not exist, otherwise return the position of the account holder in the array
*/

int search_acc(int acc_no)
{
	int i=0, k=-1 ;

	while(i<no_acc)
	{
		if(acc_no==acc_holder[i].acc_no)			// To search the account exists or not 
		{
			k=i ;
			break ;
		}
		i++ ;									
	}
	return k ;

}





// -----------------------------				#3.0.2					-------------------------------


/*
	Calculating the interest.

	This function is called before every transaction of an account to calculate the interest and give 
	the net balance of the account at that time. 
	The function to calculate compound interest on a given amount on the basis of time difference in 
	seconds calculated in such a way that the net yearly interest comes out to be 5%.
	It also updates the date of modification to the current date and time.
	
*/	



int cinterest(int k)
{

	//Converting the date in the text file from string type to time type	
	
	char buf[10000];
	
    time_t t,t2;
    
    struct tm *timeptr,result;

	strptime(acc_holder[k].domodi, "%m/%d/%Y:%H:%M:%S",&result);

	//Calculating the time with the current date
	
	
	timeptr=&result;
	t=mktime(timeptr);
	t2=time(NULL);
	
	
	double dift= difftime(t2,t);

	double rate,cinterest;
	rate=1.54606*pow(10,-9);
	
	/*
		The interest that we are calculating is compound interest, compounded per second, on the balance. 
		The formula for compound interest is :
				A = P*(1+r/100)^n
		where P = Principal amount, n = time elapsed in seconds, r = compound interest rate per second 
		while A = calculated amount after t seconds.
			Now, as per the rules of the bank, an account holder would get interest @ R = 5% per annum. 
		This rate is to be converted into rate per second such
		If P be the pr			
			A = P*(1+rate)^n
	*/ 
	
	
	acc_holder[k].balance=acc_holder[k].balance*pow((1+rate),dift);
	
	
	 //Generating Date 
	 
	 
	time_t rawtime;
  	struct tm * timeinfo;

  	time ( &rawtime );
  	timeinfo = localtime ( &rawtime );

  	strftime (acc_holder[k].domodi,15,"%m/%d/%Y:%H:%M:%S",timeinfo);
  	
  	return 0 ;
}
	






// -----------------------------				#4					-------------------------------


/*
	Uploading account details in the file "records.txt".

	During a run of the program, whatever changes the employee makes in the program, it is stored in 
	the variable structure 'acc_holder[]' and not directly in the memory. After every few transactions, 
	the employee is supposed to upload the changes he/she has made, so that the customer can make use 
	of the changed account details and get further services from the bank from some other counter. 
	In other words the employee needs to refresh the memory of the computer every few while, that is, 
	to overrite the file "records.txt" and store the updated data in it from this 'acc_holder[]' being 
	used in the program.
		This is the purpose of the program. It is given as an option in the main menu functions and 
	is also called automatically whenever the employee logs out.		
*/

void refresh()
{
	FILE *frec;

				//Creating a file to store the updated data 

	frec=fopen("records.txt","w+");
	int i=0;

				//Writing the updated records in records.txt

	while(i<no_acc)
 	{
	 	fprintf(frec,"%d %s %s %s %d %s %10.4f\n", acc_holder[i].acc_no, acc_holder[i].first_name, acc_holder[i].last_name, acc_holder[i].address, acc_holder[i].age, acc_holder[i].domodi, acc_holder[i].balance);
 	
	 	i++;
 	}
	cout<<"\nData updated\n"; 	
	
				//Closing the file pointer 

	fclose(frec);

}


